#include <sys/types.h>
#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <sys/time.h>
#include <netdb.h>
#include <string.h>
#include <unistd.h>
#include <errno.h>
#include "anw.h"

char *remotehost="127.0.0.1";
char *myname="";
unsigned short remoteport=6543;
int remotefd;

void
contact()
{
	struct hostent *he;
	struct sockaddr_in sa;
	he=gethostbyname(remotehost);
	if (!he) {
		herror(remotehost);
		exit(1);
	}
	sa.sin_family = AF_INET;
	memcpy(&sa.sin_addr,he->h_addr,4);
	sa.sin_port=htons(remoteport);
	remotefd=socket(PF_INET, SOCK_STREAM, IPPROTO_TCP);
	if (remotefd<0) {
		perror("socket");
		exit(1);
	}
	if (connect(remotefd,(struct sockaddr *)&sa,sizeof(sa))) {
		perror(remotehost);
		exit(1);
	}
	if (fcntl(remotefd,F_SETFL,O_NONBLOCK)) {
		perror(remotehost);
		exit(1);
	}
	transmit(myname,strlen(myname)+1);
}

int
receive(void *buf,const int size,const int warte)
{
	int ptr,i;
	ptr=0;
	do {
		i=read(remotefd,buf+ptr,size-ptr);
		if (i<0) {
			if (errno!=EAGAIN) gr_error(remotehost);
			if (ptr==0 && !warte) return 1;
			usleep(20000);
			continue;
		}
		if (i==0) {
			gr_close();
			fprintf(stderr,"%s: Connection terminated\n",remotehost);
			exit(1);
		}
		ptr+=i;
	} while (ptr<size);
	return 0;
}

void
transmit(void *buf,const int size)
{
	int ptr,i;
	ptr=0;
	do {
		i=write(remotefd,buf+ptr,size-ptr);
		if (i<0) {
			if (errno!=EAGAIN) gr_error(remotehost);
			continue;
		}
		if (i==0) {
			gr_close();
			fprintf(stderr,"%s: Connection terminated\n",remotehost);
			exit(1);
		}
		ptr+=i;
	} while (ptr<size);
}

fd_set fds;

void
holdit()
{
	FD_SET(0,&fds);
	FD_SET(remotefd,&fds);
	select(remotefd+1,&fds,NULL,NULL,NULL);
}
